---
updatedAt: 2026-02-10T18:31:10.000Z
---

# Create Agent Location

**This API requires the Account Administrator role.**

Creates an Agent Location for a specified account

# OpenAPI definition

```json
{
  "openapi": "3.0.2",
  "x-explorer-enabled": false,
  "x-samples-languages": [
    "curl",
    "node",
    "java",
    "javascript",
    "python",
    "go"
  ],
  "info": {
    "title": "Admin - Voice",
    "description": "The Voice provider APIs are used to manage information about voice specific elements and different voice related entities e.g. Phone numbers.\n\nVoice Services will support multiple ways to provision voice providers\n  1. Programmatic Interface (Rest APIs)\n  2. User Interface\n",
    "contact": {
      "name": "Avaya API Team",
      "url": "https://developers.avayacloud.com/onecloud-ccaas",
      "email": "apiteam@avaya.com"
    },
    "license": {
      "name": "Avaya Software Development Kit (SDK) Software License Terms",
      "url": "http://support.avaya.com/css/P8/documents/101038288"
    },
    "version": "1.0.2"
  },
  "security": [
    {},
    {
      "BearerAuth": [],
      "AppKey": []
    }
  ],
  "servers": [
    {
      "url": "{protocol}://{server}{basePath}",
      "description": "Open API",
      "variables": {
        "protocol": {
          "enum": [
            "https"
          ],
          "default": "https"
        },
        "server": {
          "default": "HOST-REGION.api.avayacloud.com"
        },
        "basePath": {
          "default": "/api/admin/voice/v1"
        }
      }
    }
  ],
  "tags": [
    {
      "name": "Agent Location",
      "description": "Agent location Routing APIs for System Administrator. It will enable agents connecting from different countries to be able to go through specific trunks or connection.\n"
    }
  ],
  "paths": {
    "/accounts/{accountId}/agent-locations": {
      "post": {
        "tags": [
          "Agent Location"
        ],
        "summary": "Create Agent Location",
        "description": "**This API requires the Account Administrator role.**\n\nCreates an Agent Location for a specified account\n",
        "operationId": "createAgentLocation",
        "parameters": [
          {
            "$ref": "#/components/parameters/accountId"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AgentLocation"
              },
              "examples": {
                "default": {
                  "$ref": "#/components/examples/AgentLocationRequest"
                }
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/AgentLocation"
                },
                "examples": {
                  "default": {
                    "$ref": "#/components/examples/AgentLocationResponse"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ErrorConstraintViolation"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "409": {
            "$ref": "#/components/responses/Conflict"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    }
  },
  "components": {
    "securitySchemes": {
      "BearerAuth": {
        "type": "http",
        "scheme": "bearer",
        "description": "This API uses Bearer Token Authorization Flow",
        "bearerFormat": "JWT"
      },
      "AppKey": {
        "type": "apiKey",
        "in": "header",
        "name": "appkey",
        "description": "This API needs an appKey as header"
      }
    },
    "responses": {
      "Unauthorized": {
        "description": "Unauthorized",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorUnauthorized"
              }
            }
          }
        }
      },
      "Forbidden": {
        "description": "Forbidden",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorForbidden"
              }
            }
          }
        }
      },
      "NotFound": {
        "description": "Not Found",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorNotFound"
              }
            }
          }
        }
      },
      "InternalServerError": {
        "description": "All other application errors",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorInternalServerError"
              }
            }
          }
        }
      },
      "ErrorConstraintViolation": {
        "description": "Constraint Violation",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorConstraintViolation"
              }
            }
          }
        }
      },
      "Conflict": {
        "description": "Conflict",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorConflict"
              }
            }
          }
        }
      }
    },
    "schemas": {
      "Problem": {
        "type": "object",
        "description": "<b>Problem Detail</b> as a way to carry machine-readable details of errors in a HTTP response to avoid the need to define new error response formats for HTTP APIs <a href=\"https://tools.ietf.org/html/rfc7807\">RFC 7807</a>\n",
        "properties": {
          "type": {
            "type": "string",
            "format": "uri",
            "description": "An absolute URI that identifies the problem type. When dereferenced, it SHOULD provide human-readable documentation for the problem type (e.g., using HTML).\n",
            "default": "about:blank",
            "example": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#constraint-violation"
          },
          "title": {
            "type": "string",
            "description": "A short, summary of the problem type. Written in english and readable for engineers (usually not suited for non technical stakeholders and not localized).\n",
            "example": "Service Unavailable",
            "nullable": true
          },
          "status": {
            "type": "integer",
            "format": "int32",
            "description": "The HTTP status code generated by the origin server for this occurrence of the problem.\n",
            "minimum": 100,
            "maximum": 600,
            "exclusiveMaximum": true,
            "example": 503,
            "nullable": true
          },
          "detail": {
            "type": "string",
            "description": "A human readable explanation specific to this occurrence of the problem.\n",
            "example": "Connection to database timed out",
            "nullable": true
          },
          "instance": {
            "type": "string",
            "format": "uri",
            "description": "An absolute URI that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.\n",
            "nullable": true
          },
          "violations": {
            "type": "array",
            "description": "A list of violations that occurred as a result of invalid data provided as part of a request.\n",
            "nullable": true,
            "items": {
              "type": "object",
              "properties": {
                "field": {
                  "type": "string",
                  "description": "The name of the field in the request that caused the violation. This can be the name of a path parameter, query parameter, or a field within the request body.\n",
                  "example": "accountId"
                },
                "message": {
                  "type": "string",
                  "description": "A human readable explanation specific to this occurrence of the violation.\n",
                  "example": "must match \"^[a-zA-Z]{6}$\""
                },
                "code": {
                  "type": "integer",
                  "format": "int32",
                  "description": "The violation code generated by the server for this occurrence of the violation. Use this code when implementing any error handling logic instead of the message, as the message can change.\n",
                  "example": 20006
                }
              }
            },
            "example": [
              {
                "field": "emailAddress",
                "message": "must not be null",
                "code": 20002
              },
              {
                "field": "accountId",
                "message": "must match \"^[a-zA-Z]{6}$\"",
                "code": 20006
              }
            ]
          }
        }
      },
      "AgentLocation": {
        "description": "Agent Location",
        "type": "object",
        "properties": {
          "id": {
            "type": "string",
            "description": "The unique Id of Agent Location",
            "readOnly": true,
            "example": "c8c2909d-75e9-484a-94c0-b7e8d29771fe",
            "minLength": 36,
            "maxLength": 36,
            "pattern": "^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$"
          },
          "name": {
            "type": "string",
            "description": "Agent Location Name",
            "example": "uk-1-location-id",
            "minLength": 3,
            "maxLength": 255,
            "pattern": "^[a-zA-Z0-9\\p{L}\\-\\_\\.\\ ]+$"
          },
          "description": {
            "type": "string",
            "example": "Description of the Agent Location",
            "maxLength": 255,
            "pattern": "(^$|^[a-zA-Z0-9\\p{L}\\(\\)\\-\\_\\.\\ \\n]+$)"
          },
          "isDialingRestrictionEnabled": {
            "type": "boolean",
            "description": "It is an indicator to enable or disable Dialing Restriction",
            "example": true,
            "default": false
          },
          "users": {
            "type": "array",
            "readOnly": true,
            "items": {
              "$ref": "#/components/schemas/AgentLocationUser"
            }
          },
          "outboundRoutingRules": {
            "type": "array",
            "readOnly": true,
            "items": {
              "$ref": "#/components/schemas/AgentLocationOutboundRoutingRule"
            }
          }
        },
        "required": [
          "name",
          "isDialingRestrictionEnabled"
        ]
      },
      "AgentLocationUser": {
        "type": "object",
        "description": "List of Users associated with Agent Location",
        "properties": {
          "userId": {
            "type": "string",
            "description": "The unique Id of User",
            "example": "c8c2909d-75e9-484a-94c0-b7e8d29771fe",
            "minLength": 36,
            "maxLength": 36,
            "pattern": "^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$"
          },
          "loginId": {
            "type": "string",
            "description": "User Login Id",
            "example": "user@avaya.com"
          }
        }
      },
      "AgentLocationOutboundRoutingRule": {
        "type": "object",
        "description": "List of Users associated with Agent Location",
        "properties": {
          "id": {
            "type": "string",
            "description": "The unique Id of Outbound Routing Rule",
            "example": "c8c2909d-75e9-484a-94c0-b7e8d29771fe",
            "minLength": 36,
            "maxLength": 36,
            "pattern": "^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$"
          },
          "name": {
            "type": "string",
            "description": "Outbound Routing Rule Name",
            "example": "uk-1-location-id",
            "minLength": 3,
            "maxLength": 255,
            "pattern": "^[a-zA-Z0-9\\p{L}\\-\\_\\.\\ ]+$"
          }
        }
      }
    },
    "parameters": {
      "accountId": {
        "name": "accountId",
        "description": "The unique 6 character internal id that represents the customer account.",
        "required": true,
        "in": "path",
        "schema": {
          "type": "string",
          "minLength": 6,
          "maxLength": 6,
          "pattern": "^[a-zA-Z]{6}$",
          "example": "ABCDEF"
        }
      }
    },
    "examples": {
      "ErrorUnauthorized": {
        "description": "Unauthorized",
        "value": {
          "type": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#unauthorized",
          "title": "Unauthorized",
          "status": 401,
          "detail": "This operation requires authentication. See https://developers.avayacloud.com/onecloud-ccaas/docs/how-to-authenticate-with-ccaas-apis"
        }
      },
      "ErrorForbidden": {
        "description": "Forbidden",
        "value": {
          "type": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#forbidden",
          "title": "Forbidden",
          "status": 403,
          "detail": "According to the access control policy the current user does not have permission to access this resource."
        }
      },
      "ErrorNotFound": {
        "description": "Not Found",
        "value": {
          "type": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#resource-not-found",
          "title": "Resource Not Found",
          "status": 404,
          "detail": "Either there is no API method associated with the URL path of the request, or the request refers to one or more resources that were not found."
        }
      },
      "ErrorInternalServerError": {
        "description": "Server Error",
        "value": {
          "type": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#server-error",
          "title": "Server Error",
          "status": 500,
          "detail": "An internal server error was encountered."
        }
      },
      "ErrorConstraintViolation": {
        "description": "Constraint Violation",
        "value": {
          "type": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#constraint-violation",
          "title": "Constraint Violation",
          "status": 400,
          "detail": "A problem that indicates a syntactically correct, yet semantically illegal request. The Server can not process this request until the client resolves the semantic errors described in the violations section.",
          "violations": [
            {
              "field": "accountId",
              "message": "must match \"^[a-zA-Z]{6}$\"",
              "code": 20006
            }
          ]
        }
      },
      "ErrorConflict": {
        "description": "Conflict",
        "value": {
          "type": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#conflict",
          "title": "Conflict",
          "status": 409,
          "detail": "A resource with the same unique constraint values already exists.",
          "violations": [
            {
              "field": "name",
              "message": "Communication Manager with same name already exists."
            },
            {
              "field": "hostname",
              "message": "Communication Manager with same hostname already exists."
            }
          ]
        }
      },
      "AgentLocationRequest": {
        "description": "Request model for creating and Updating an Agent Location",
        "value": {
          "name": "uk-1-location-id",
          "description": "UK Agent Location 1",
          "isDialingRestrictionEnabled": true,
          "users": [
            {
              "userId": "18e4f754-5e42-4387-ae13-e9b4fe4aed29",
              "loginId": "johndoe1@test.com"
            },
            {
              "userId": "18e4f754-5e42-4387-ae13-e9b4fe4aed30",
              "loginId": "johndoe2@test.com"
            }
          ],
          "outboundRoutingRules": [
            {
              "id": "18e4f754-5e42-4387-ae13-e9b4fe4aed29",
              "name": "Outbound Rule"
            }
          ]
        }
      },
      "AgentLocationResponse": {
        "description": "Response model for get an Agent Location",
        "value": {
          "id": "18e4f754-5e42-4387-ae13-e9b4fe4aed29",
          "name": "uk-1-location-id",
          "description": "UK Agent Location 1",
          "isDialingRestrictionEnabled": true,
          "users": [
            {
              "userId": "18e4f754-5e42-4387-ae13-e9b4fe4aed29",
              "loginId": "johndoe1@test.com"
            },
            {
              "userId": "18e4f754-5e42-4387-ae13-e9b4fe4aed30",
              "loginId": "johndoe2@test.com"
            }
          ],
          "outboundRoutingRules": [
            {
              "id": "18e4f754-5e42-4387-ae13-e9b4fe4aed29",
              "name": "Outbound Rule"
            }
          ]
        }
      }
    }
  },
  "x-readme": {
    "proxy-enabled": true
  }
}
```